this.noble_food_event <- this.inherit("scripts/events/event", {
	m = {},
	function create()
	{
		this.m.ID = "event.noble_food_event";
		this.m.Title = "During camp...";
		this.m.Cooldown = 14.0 * this.World.getTime().SecondsPerDay;
		this.m.Screens.push({
			ID = "A",
			Text = "[img]gfx/ui/events/event_52.png[/img]{That\'s bad idea to make your people hungry. Plate without slice of meat isn\'t a proper food for veterans or skillful sellswords. You found your men being in discontented mood, so probably you have to solve this probles as soon as possible.}",
			Image = "",
			List = [],
			Characters = [],
			Options = [
				{
					Text = "I hope they don\'t eat away each others.",
					function getResult( _event )
					{
						return 0;
					}

				}
			],
			function start( _event )
			{
				local brothers = this.World.getPlayerRoster().getAll();

				foreach( bro in brothers )
				{
					if (bro.getBackground().getID() == "background.disowned_noble" ||
						bro.getBackground().getID() == "background.adventurous_noble" ||
						bro.getBackground().getID() == "background.sellsword" ||
						bro.getBackground().getID() == "background.bastard" ||
						bro.getBackground().getID() == "background.raider")
					{
						bro.worsenMood(0.5, "Has no meat for a long time");

						if (bro.getMoodState() < this.Const.MoodState.Neutral)
						{
							this.List.push({
								id = 10,
								icon = this.Const.MoodStateIcon[bro.getMoodState()],
								text = bro.getName() + this.Const.MoodStateEvent[bro.getMoodState()]
							});
						}
					}
				}
			}

		});
	}

	function onUpdateScore()
	{
		if (this.World.State.getEscortedEntity() != null)
		{
			return;
		}

		local brothers = this.World.getPlayerRoster().getAll();
		local veterans = 0;

		foreach( bro in brothers )
		{
			if (bro.getBackground().getID() == "background.disowned_noble" ||
						bro.getBackground().getID() == "background.adventurous_noble" ||
						bro.getBackground().getID() == "background.sellsword" ||
						bro.getBackground().getID() == "background.bastard" ||
						bro.getBackground().getID() == "background.raider")
			{
				veterans++;
			}
		}

		if (veterans == 0)
		{
			return;
		}

		local stash = this.World.Assets.getStash().getItems();
		local hasMeat = false;

		foreach( item in stash )
		{
			if (item != null && item.isItemType(this.Const.Items.ItemType.Food))
			{
				if (item.getID() == "supplies.smoked_ham" || 
				item.getID() == "supplies.cured_rations" ||
				item.getID() == "supplies.cured_venison")
				{
					hasMeat = true;
				}
			}
		}

		if (hasMeat)
		{
			return;
		}

		this.m.Score = veterans * 5;
	}

	function onPrepare()
	{
	}

	function onPrepareVariables( _vars )
	{
	}

	function onClear()
	{
	}

});
