this.scenario_ghouls <- this.inherit("scripts/scenarios/tactical/scenario_template", {
	m = {},
	function generate()
	{
		this.logDebug("ScenarioDefendTheHill::generate()");
		this.createStash();
		this.initMap();
		this.initEntities();
		this.initStash();
		this.m.Music = this.Const.Music.BeastsTracks;
		local entity;

		for( local i = 0; i < 8; i = ++i )
		{
			entity = this.spawnEntity("scripts/entity/tactical/humans/militia");
			entity.assignRandomEquipment();
			entity.killSilently();
		}

		this.Tactical.Entities.makeEnemiesKnownToAI();
		local clouds = this.Tactical.getWeather().createCloudSettings();
		clouds.Type = this.getconsttable().CloudType.StaticFog;
		clouds.MinClouds = 12;
		clouds.MaxClouds = 18;
		clouds.MinAlpha = 0.25;
		clouds.MaxAlpha = 0.5;
		clouds.MinScale = 2.0;
		clouds.MaxScale = 3.0;
		this.Tactical.getWeather().buildCloudCover(clouds);
		local rain = this.Tactical.getWeather().createRainSettings();
		rain.MinDrops = 150;
		rain.MaxDrops = 150;
		rain.NumSplats = 50;
		rain.MinVelocity = 400.0;
		rain.MaxVelocity = 500.0;
		rain.MinAlpha = 1.0;
		rain.MaxAlpha = 1.0;
		rain.MinScale = 0.75;
		rain.MaxScale = 1.0;
		this.Tactical.getWeather().buildRain(rain);
		this.Tactical.getWeather().setAmbientLightingPreset(5);
		this.Tactical.getWeather().setAmbientLightingSaturation(0.9);
		this.Tactical.CameraDirector.addMoveToTileEvent(0, this.Tactical.getTile(15, 15 - 15 / 2), 3, null, null, 0, 2000);
		this.Tactical.CameraDirector.addMoveToTileEvent(0, this.Tactical.getTile(9, 15 - 9 / 2), -1, null, null, 0, 1800);
		this.Tactical.CameraDirector.addMoveToTileEvent(0, this.Tactical.getTile(15, 8 - 15 / 2), -1, null, null, 0, 1800);
		this.Tactical.CameraDirector.addMoveToTileEvent(0, this.Tactical.getTile(21, 15 - 21 / 2), -1, null, null, 0, 1800);
		this.Tactical.CameraDirector.addMoveToTileEvent(0, this.Tactical.getTile(15, 21 - 15 / 2), -1, null, null, 0, 1800);
		this.Tactical.CameraDirector.addMoveToTileEvent(0, this.Tactical.getTile(15, 15 - 15 / 2), -1, null, null, 0, 500);
		this.Sound.setAmbience(0, this.Const.SoundAmbience.Rain, this.Const.Sound.Volume.Ambience, 0);
	}

	function initMap()
	{
		local testMap = this.MapGen.get("tactical.defend_the_hill");
		local minX = testMap.getMinX();
		local minY = testMap.getMinY();
		this.Tactical.resizeScene(minX, minY);
		testMap.fill({
			X = 0,
			Y = 0,
			W = minX,
			H = minY
		}, null);
	}

	function initEntities()
	{
		local entity;
		local items;

		for( local x = 12; x <= 13; x = ++x )
		{
			for( local y = 15; y < 21; y = ++y )
			{
				entity = this.spawnEntity("scripts/entity/tactical/player", x, x, y, y);
				this.World.getPlayerRoster().add(entity);
				entity.setName(this.getRandomPlayerName());
				entity.setScenarioValues();

				local skill = this.new("scripts/skills/special/light_equipment_spec");
				entity.getSkills().add(skill);
				skill = this.new("scripts/skills/perks/perk_quick_hands");
				entity.getSkills().add(skill);

				items = entity.getItems();
				if (x == 12)
				{
					items.equip(this.new("scripts/items/helmets/closed_mail_coif"));
					items.equip(this.new("scripts/items/armor/padded_leather"));
					items.equip(this.new("scripts/items/ammo/quiver_of_arrows"));
					items.equip(this.new("scripts/items/weapons/hunting_bow"));
				}
				else
				{
					items.equip(this.new("scripts/items/helmets/kettle_hat"));
					items.equip(this.new("scripts/items/armor/mail_shirt"));
					items.equip(this.new("scripts/items/weapons/warfork"));
				}
			}
		}

		entity = this.spawnEntity("scripts/entity/tactical/enemies/ghoul", 12, 18, 7, 10);
		entity.setFaction(this.Const.Faction.Undead);
		entity.assignRandomEquipment();
		entity = this.spawnEntity("scripts/entity/tactical/enemies/ghoul", 12, 18, 7, 10);
		entity.setFaction(this.Const.Faction.Undead);
		entity.assignRandomEquipment();
		entity = this.spawnEntity("scripts/entity/tactical/enemies/ghoul", 12, 18, 7, 10);
		entity.setFaction(this.Const.Faction.Undead);
		entity.assignRandomEquipment();
		entity = this.spawnEntity("scripts/entity/tactical/enemies/ghoul", 12, 18, 7, 10);
		entity.setFaction(this.Const.Faction.Undead);
		entity.assignRandomEquipment();
		entity = this.spawnEntity("scripts/entity/tactical/enemies/ghoul", 20, 22, 12, 18);
		entity.setFaction(this.Const.Faction.Undead);
		entity.assignRandomEquipment();
		entity = this.spawnEntity("scripts/entity/tactical/enemies/ghoul", 20, 22, 12, 18);
		entity.setFaction(this.Const.Faction.Undead);
		entity.assignRandomEquipment();
		entity = this.spawnEntity("scripts/entity/tactical/enemies/ghoul", 20, 22, 12, 18);
		entity.setFaction(this.Const.Faction.Undead);
		entity.assignRandomEquipment();
		entity = this.spawnEntity("scripts/entity/tactical/enemies/ghoul", 20, 22, 12, 18);
		entity.setFaction(this.Const.Faction.Undead);
		entity.assignRandomEquipment();
		entity = this.spawnEntity("scripts/entity/tactical/enemies/ghoul", 21, 22, 16, 20);
		entity.setFaction(this.Const.Faction.Undead);
		entity.assignRandomEquipment();
		entity = this.spawnEntity("scripts/entity/tactical/enemies/ghoul", 7, 10, 12, 18);
		entity.setFaction(this.Const.Faction.Undead);
		entity.assignRandomEquipment();
		entity = this.spawnEntity("scripts/entity/tactical/enemies/ghoul", 7, 10, 12, 18);
		entity.setFaction(this.Const.Faction.Undead);
		entity.assignRandomEquipment();
		entity = this.spawnEntity("scripts/entity/tactical/enemies/ghoul", 7, 10, 12, 18);
		entity.setFaction(this.Const.Faction.Undead);
		entity.assignRandomEquipment();
		entity = this.spawnEntity("scripts/entity/tactical/enemies/ghoul", 7, 10, 12, 18);
		entity.setFaction(this.Const.Faction.Undead);
		entity.assignRandomEquipment();
		entity = this.spawnEntity("scripts/entity/tactical/enemies/ghoul", 7, 10, 12, 18);
		entity.setFaction(this.Const.Faction.Undead);
		entity.assignRandomEquipment();
		entity = this.spawnEntity("scripts/entity/tactical/enemies/ghoul", 13, 17, 21, 23);
		entity.setFaction(this.Const.Faction.Undead);
		entity.assignRandomEquipment();
		entity = this.spawnEntity("scripts/entity/tactical/enemies/ghoul", 13, 17, 21, 23);
		entity.setFaction(this.Const.Faction.Undead);
		entity.assignRandomEquipment();
		entity = this.spawnEntity("scripts/entity/tactical/enemies/ghoul", 13, 17, 21, 23);
		entity.setFaction(this.Const.Faction.Undead);
		entity.assignRandomEquipment();
	}

	function spawnEntity( _script, _minX = 8, _maxX = 26, _minY = 8, _maxY = 26 )
	{
		local x = 0;
		local y = 0;

		while (1)
		{
			x = this.Math.rand(_minX, _maxX);
			y = this.Math.rand(_minY, _maxY) - x / 2;

			if (this.Tactical.getTile(x, y).IsEmpty)
			{
				break;
			}
		}

		return this.Tactical.spawnEntity(_script, x, y);
	}

	function initStash()
	{
		this.Stash.clear();
		this.Stash.resize(117);
		this.Stash.setLocked(false);
		this.Stash.add(this.new("scripts/items/weapons/dagger"));
		this.Stash.add(this.new("scripts/items/weapons/hand_axe"));
		this.Stash.add(this.new("scripts/items/weapons/warhammer"));
		this.Stash.add(this.new("scripts/items/weapons/warhammer"));
		this.Stash.add(this.new("scripts/items/weapons/falchion"));
		this.Stash.add(this.new("scripts/items/weapons/arming_sword"));
		this.Stash.add(this.new("scripts/items/weapons/noble_sword"));
		this.Stash.add(this.new("scripts/items/weapons/military_cleaver"));
		this.Stash.add(this.new("scripts/items/weapons/military_cleaver"));
		this.Stash.add(this.new("scripts/items/weapons/greatsword"));
		this.Stash.add(this.new("scripts/items/weapons/greatsword"));
		this.Stash.add(this.new("scripts/items/weapons/billhook"));
		this.Stash.add(this.new("scripts/items/weapons/billhook"));
		this.Stash.add(this.new("scripts/items/weapons/winged_mace"));
		this.Stash.add(this.new("scripts/items/weapons/winged_mace"));
		this.Stash.add(this.new("scripts/items/weapons/flail"));
		this.Stash.add(this.new("scripts/items/weapons/flail"));
		this.Stash.add(this.new("scripts/items/weapons/boar_spear"));
		this.Stash.add(this.new("scripts/items/weapons/boar_spear"));
		this.Stash.add(this.new("scripts/items/weapons/hunting_bow"));
		this.Stash.add(this.new("scripts/items/weapons/hunting_bow"));
		this.Stash.add(this.new("scripts/items/weapons/crossbow"));
		this.Stash.add(this.new("scripts/items/weapons/crossbow"));
		this.Stash.add(this.new("scripts/items/shields/wooden_shield"));
		this.Stash.add(this.new("scripts/items/shields/wooden_shield"));
		this.Stash.add(this.new("scripts/items/shields/wooden_shield"));
		this.Stash.add(this.new("scripts/items/shields/kite_shield"));
		this.Stash.add(this.new("scripts/items/helmets/hood"));
		this.Stash.add(this.new("scripts/items/helmets/full_aketon_cap"));
		this.Stash.add(this.new("scripts/items/helmets/padded_nasal_helmet"));
		this.Stash.add(this.new("scripts/items/helmets/mail_coif"));
		this.Stash.add(this.new("scripts/items/helmets/kettle_hat"));
		this.Stash.add(this.new("scripts/items/helmets/flat_top_helmet"));
		this.Stash.add(this.new("scripts/items/helmets/full_helm"));
		this.Stash.add(this.new("scripts/items/armor/gambeson"));
		this.Stash.add(this.new("scripts/items/armor/padded_surcoat"));
		this.Stash.add(this.new("scripts/items/armor/padded_leather"));
		this.Stash.add(this.new("scripts/items/armor/mail_shirt"));
		this.Stash.add(this.new("scripts/items/armor/lamellar_harness"));
		this.Stash.add(this.new("scripts/items/ammo/quiver_of_arrows"));
		this.Stash.add(this.new("scripts/items/ammo/quiver_of_arrows"));
		this.Stash.add(this.new("scripts/items/ammo/quiver_of_bolts"));
		this.Stash.add(this.new("scripts/items/ammo/quiver_of_bolts"));
	}

});
