this.encourage <- this.inherit("scripts/skills/skill", {
	m = {},
	function create()
	{
		this.m.ID = "actives.encourage";
		this.m.Name = "Encourage";
		this.m.Description = "Encourage allie to fight as bear and deal more damage. The more both of characters have resolve the better result.";
		this.m.Icon = "skills/active_encourage.png";
		this.m.IconDisabled = "skills/active_encourage_sw.png";
		this.m.Overlay = "status_effect_encourage";
		this.m.SoundOnUse = [
			"sounds/combat/inspire_01.wav",
			"sounds/combat/inspire_02.wav"
		];
		this.m.Type = this.Const.SkillType.Active;
		this.m.Order = this.Const.SkillOrder.Any;
		this.m.IsSerialized = false;
		this.m.IsActive = true;
		this.m.IsTargeted = true;
		this.m.IsStacking = false;
		this.m.IsAttack = false;
		this.m.IsIgnoredAsAOO = true;
		this.m.IsUsingHitchance = false;
		this.m.ActionPointCost = 5;
		this.m.FatigueCost = 20;
		this.m.MinRange = 1;
		this.m.MaxRange = 1;
		this.m.MaxLevelDifference = 4;
	}

	function getTooltip()
	{
		local ret = [
			{
				id = 1,
				type = "title",
				text = this.getName()
			},
			{
				id = 2,
				type = "description",
				text = this.getDescription()
			},
			{
				id = 3,
				type = "text",
				text = this.getCostString()
			}
		];
		return ret;
	}

	function onVerifyTarget( _originTile, _targetTile )
	{
		if (!this.skill.onVerifyTarget(_originTile, _targetTile))
		{
			return false;
		}

		if (!this.m.Container.getActor().isAlliedWith(_targetTile.getEntity()))
		{
			return false;
		}

		if (this.m.Container.getActor().getSkills().hasSkill("effect.encourage"))
		{
			return false;
		}

		return true;
	}

	function onUse( _user, _targetTile )
	{
		local target = _targetTile.getEntity();
		local effect = this.new("scripts/skills/effects/encourage_effect");
		effect.setBonus(3 + (this.Math.rand(0, 100) > _user.getBravery() ? 0 : 5) + (this.Math.rand(0, 100) > target.getBravery() ? 0 : 7));

		target.getSkills().add(effect);
		return true;
	}
});
