this.encourage_effect <- this.inherit("scripts/skills/skill", {
	m = {
		TurnsLeft = 2,
		Bonus = 0
	},
	function create()
	{
		this.m.ID = "encourage_effect";
		this.m.Name = "Encourage";
		this.m.Icon = "skills/status_effect_encourage.png";
		this.m.IconMini = "status_effect_encourage_mini";
		this.m.Overlay = "status_effect_encourage";
		this.m.Type = this.Const.SkillType.StatusEffect;
		this.m.IsActive = false;
		this.m.IsStacking = false;
		this.m.IsRemovedAfterBattle = true;
	}

	function getDescription()
	{
		return "This character is encouraged for [color=" + this.Const.UI.Color.PositiveValue + "]" + this.m.TurnsLeft + "[/color] more turn(s).";
	}

	function getTooltip()
	{
		return [
			{
				id = 1,
				type = "title",
				text = this.getName()
			},
			{
				id = 2,
				type = "description",
				text = this.getDescription()
			},
			{
				id = 10,
				type = "text",
				icon = "ui/icons/special.png",
				text = "[color=" + this.Const.UI.Color.PositiveValue + "]+" + this.m.Bonus + "%[/color] Damage"
			}
		];
	}

	function setBonus(_f)
	{
		this.m.Bonus = _f;
	}

	function onAdded()
	{
	}

	function onUpdate( _properties )
	{
		_properties.DamageTotalMult *= (1 + this.m.Bonus / 100);
	}

	function onTurnEnd()
	{
		if (--this.m.TurnsLeft <= 0)
		{
			this.removeSelf();
		}
	}

});
