this.lone_wolf_effect <- this.inherit("scripts/skills/skill", {
	m = {
		Bonus = 0,
	},
	function create()
	{
		this.m.ID = "effects.lone_wolf";
		this.m.Name = "Lone Wolf";
		this.m.Description = "I work best alone, gain bonus to Melee and Ranged Skill and Defense based on resolve. Have penalty if allie stays near.";
		this.m.Icon = "ui/perks/perk_61.png";
		this.m.IconMini = "perk_61_mini";
		this.m.Type = this.Const.SkillType.StatusEffect;
		this.m.Order = this.Const.SkillOrder.VeryLast;
		this.m.IsActive = false;
		this.m.IsStacking = false;
	}

	function getTooltip()
	{
		return [
			{
				id = 1,
				type = "title",
				text = this.getName()
			},
			{
				id = 2,
				type = "description",
				text = this.getDescription()
			},
			{
				id = 10,
				type = "text",
				icon = "ui/icons/melee_skill.png",
				text = "[color=" + this.Const.UI.Color.PositiveValue + "]+" + this.m.Bonus + "[/color] Melee Skill"
			},
			{
				id = 10,
				type = "text",
				icon = "ui/icons/ranged_skill.png",
				text = "[color=" + this.Const.UI.Color.PositiveValue + "]+" + this.m.Bonus + "[/color] Ranged Skill"
			},
			{
				id = 10,
				type = "text",
				icon = "ui/icons/melee_defense.png",
				text = "[color=" + this.Const.UI.Color.PositiveValue + "]+" + this.m.Bonus + "[/color] Melee Defense"
			},
			{
				id = 10,
				type = "text",
				icon = "ui/icons/ranged_defense.png",
				text = "[color=" + this.Const.UI.Color.PositiveValue + "]+" + this.m.Bonus + "[/color] Ranged Defense"
			}
		];
	}

	function onAfterUpdate( _properties )
	{
		if (!this.getContainer().getActor().isPlacedOnMap())
		{
			this.m.IsHidden = true;
			return;
		}

		local actor = this.getContainer().getActor();
		local myTile = actor.getTile();
		local allies = this.Tactical.Entities.getInstancesOfFaction(actor.getFaction());
		local minDistance = 999;

		foreach( ally in allies )
		{
			if (ally.getID() == actor.getID() || !ally.isPlacedOnMap())
			{
				continue;
			}

			minDistance = this.Math.min(minDistance, ally.getTile().getDistanceTo(myTile))

			if (minDistance == 1)
			{
				break;
			}
		}

		if (minDistance > 1)
		{
			this.m.IsHidden = false;
			local percent = minDistance <= 3 ? (minDistance == 3 ? 0.5 : 0.25) : 1;
			this.m.Bonus = this.Math.ceil(this.getContainer().getActor().getBravery() * percent * 0.15);

			_properties.MeleeSkill += this.m.Bonus;
			_properties.RangedSkill += this.m.Bonus;
			_properties.MeleeDefense += this.m.Bonus;
			_properties.RangedDefense += this.m.Bonus;
		}
		else
		{
			this.m.Bonus = 0;
			this.m.IsHidden = true;
		}
	}

	function onCombatFinished()
	{
		this.m.IsHidden = true;
	}

});
