this.perk_backstabber <- this.inherit("scripts/skills/skill", {
	m = {
		Frame = 0,
		SkillCount = 0
	},
	function create()
	{
		this.m.ID = "perk.backstabber";
		this.m.Name = this.Const.Strings.PerkName.Backstabber;
		this.m.Description = this.Const.Strings.PerkDescription.Backstabber;
		this.m.Icon = "ui/perks/perk_59.png";
		this.m.Type = this.Const.SkillType.Perk;
		this.m.Order = this.Const.SkillOrder.Perk;
		this.m.IsActive = false;
		this.m.IsStacking = false;
		this.m.IsHidden = false;
	}

	function onUpdate( _properties )
	{
		_properties.SurroundedBonus = 10;
	}

	function onTargetMissed( _skill, _targetEntity )
	{
		if (!this.m.IsTalented || _skill.isRanged() || _targetEntity.getSurroundedCount() == 0)
		{
			return;
		}

		if (this.Time.getFrame() != this.m.Frame && this.m.SkillCount != this.Const.SkillCounter)
		{
			this.m.Frame = this.Time.getFrame();
			this.m.SkillCount = this.Const.SkillCounter;

			local bonusAP = this.Math.min(2, this.Math.ceil(_targetEntity.getSurroundedCount() / 2));
			local bonusFatigue = _skill.getFatigueCostRaw() * this.Math.minf(1, _targetEntity.getSurroundedCount() * 0.25);

			local actor = this.m.Container.getActor();
			actor.setFatigue(actor.getFatigue() - bonusFatigue);
			actor.setActionPoints(this.Math.min(actor.getActionPointsMax(), actor.getActionPoints() + bonusAP));

			this.spawnIcon("perk_59", actor.getTile());
		}
	}
});
