this.perk_killing_frenzy <- this.inherit("scripts/skills/skill", {
	m = {
		Bonus = 0
	},
	function create()
	{
		this.m.ID = "perk.killing_frenzy";
		this.m.Name = this.Const.Strings.PerkName.KillingFrenzy;
		this.m.Description = this.Const.Strings.PerkDescription.KillingFrenzy;
		this.m.Icon = "ui/perks/perk_36.png";
		this.m.Type = this.Const.SkillType.Perk | this.Const.SkillType.StatusEffect;
		this.m.Order = this.Const.SkillOrder.Perk;
		this.m.IsActive = false;
		this.m.IsStacking = false;
		this.m.IsHidden = false;
	}

	function getTooltip()
	{
		return [
			{
				id = 1,
				type = "title",
				text = this.getName()
			},
			{
				id = 2,
				type = "description",
				text = "Deal more damage in melee based on current hitpoints"
			},
			{
				id = 10,
				type = "text",
				icon = "ui/icons/damage_dealt.png",
				text = "[color=" + this.Const.UI.Color.PositiveValue + "]+" + this.m.Bonus + "%[/color] Damage in Melee"
			}
		];
	}

	function onAfterUpdate( _properties )
	{
		this.m.Bonus = this.Math.max(0, this.Math.ceil((this.getContainer().getActor().getHitpoints() - 50) * 0.5));
	}

	function onUpdated( _properties )
	{
		_properties.MeleeDamageMult *= (1 + this.m.Bonus / 100);
	}
});
