this.perk_pathfinder <- this.inherit("scripts/skills/skill", {
	m = {
		Enabled = false,
		FirstTurn = false,
		ExtraBonus = 0
	},
	function create()
	{
		this.m.ID = "perk.pathfinder";
		this.m.Name = this.Const.Strings.PerkName.Pathfinder;
		this.m.Description = this.Const.Strings.PerkDescription.Pathfinder;
		this.m.Icon = "ui/perks/perk_23.png";
		this.m.Type = this.Const.SkillType.Perk;
		this.m.Order = this.Const.SkillOrder.Perk;
		this.m.IsActive = false;
		this.m.IsStacking = false;
		this.m.IsHidden = false;
	}

	function onUpdate( _properties )
	{
		local actor = this.getContainer().getActor();
		actor.m.ActionPointCosts = this.Const.PathfinderMovementAPCost;
		actor.m.FatigueCosts = clone this.Const.PathfinderMovementFatigueCost;
		actor.m.LevelActionPointCost = 0;
	}

	function onCombatStarted()
	{
		this.m.FirstTurn = this.m.IsTalented;
	}

	function onTurnStart()
	{
		this.m.Enabled = true;

		if (this.m.FirstTurn)
		{
			this.m.ExtraBonus = 3;
			this.m.FirstTurn = false;
		}
		else
		{
			this.m.ExtraBonus = 0;
		}
	}

	function onMovementStep(_tile, _levelDifference)
	{
		if (this.m.Enabled)
		{
			local actor = this.getContainer().getActor();
			actor.setActionPoints(this.Math.min(actor.getActionPointsMax(), actor.getActionPoints() + 1));
			actor.setDirty(true);

			this.m.Enabled = this.m.ExtraBonus > 0;
			this.m.ExtraBonus = this.m.ExtraBonus - 1;
		}
	}
});
